\documentclass[]{IEEEtran} % this is what makes it being in 2 columns
% Your packages go here
\usepackage[utf8]{inputenc}
\usepackage[utf8]{inputenc}
\usepackage[T1]{fontenc}
\usepackage[english]{babel}
\usepackage{amsmath, amsthm, amssymb, amsfonts}
\usepackage{enumerate}
\usepackage{graphicx}
\usepackage{hyperref}

\markboth{T-578-ITCV Computer Vision}{}

\begin{document}
  \title{Final project report}
  \author{
    Arnór Þorleifsson, arnort20@ru.is, 2311962509\\
    Paul Coste, paul21@ru.is, 7810002785
  }
  \maketitle
  
  \section{Introduction}
  \par In all standardized chess tournaments, each player is required to record his own moves and those of his opponent in the correct manner, move after move, as clearly and legibly as possible, in the algebraic notation. This can be quite time consuming and it would help if there was a referee or observer to sort this out automatically.
  The objective of this project is to create an automatic chess observer that operates by having a camera pointed at the board.

\section{Related work - Chess Position Digitiser and Evaluator App with YOLOv4}
\begin{figure}[h]
        \centering
        \includegraphics[width=3in]{images/yolov4.png}
        \caption{The setup involved}
        \label{fig:Detecting}
    \end{figure}
\par We found one video on Youtube with less than a thousand views that details the development of a smartphone app that works by taking a photo of a chessboard overhead that outputs the recommended move after feeding it into the chess AI Stockfish.
\par This involved a huge amount of work and setup. This includes having a professional level camera rig and turntable to map every chess piece at 3 or 4 different heights and 12 different angles (figure 1), this is used to create a detailed and textured 3D model of each piece. This is then used to train a neural network using YOLOv4.
\par this would have been too much to do with our limited material and time.




  \section{Body}
  The main objectives we needed to accomplish to reach our goal were the following:
  \begin{itemize}
      \item detect the board 
      \item detect when a movement occurred on the board
      \item update chess board information
      \item output chess board representation
      \item (optional) announce when a player has made and illegal move or checkmate has occurred
  \end{itemize}
  \subsection{Detecting the board}
        \begin{figure}[h]
        \centering
        \includegraphics[width=3.5in]{images/boarded.png}
        \caption{finding the grid in the chessboard.}
        \label{fig:Detecting}
    \end{figure}
    \par As can be seen in figure 2, detecting all the squares in the board is an easy task because the corners are clear. However, this gets a bit tricky when the pieces are on the board and obscuring it.
    This was achieved by passing the image through a series of filters that had been fine-tuned for best results, as seen in figure 3. These fine-tunings were later depreciated in favor of a simpler code that is far more generalized and thus able to function in different lighting environments.
        \begin{figure}[h]
        \centering
        \includegraphics[width=3.5in]{images/filters.png}
        \caption{finding the grid in a set up board.}
        \label{fig:Filtering}
    \end{figure}
    
    \par At the beginning of the game the fourth middle rows are empty and allow us to more easily detect the board. Once the board is detected we warp the board (and only the board, the original image is cropped) on a 2D plane using a homography function and a 2D image of an empty chessboard. 
    This function will then be used for all the next frames of the video, without trying to detect the chessboard again which requires the chessboard to be static in the camera view for the rest of the game.
    \begin{figure}[h]
        \centering
        \includegraphics[width=2in]{images/3d.jpg}
        \includegraphics[width=1.5in]{images/2d.jpg}
        \caption{The original footage and the projection cropped around the board.}
        \label{fig:Filtering}
    \end{figure}
    
    \newpage
    \subsection{Detecting movements on the board}
    
    \par Once the chessboard is detected, the game can start. An image of the board is saved as the first state. The goal is now to be able to detect when a player makes a move to then be able to guess what that move is.
    From now on, every second the code checks if there is significant changes compared to the second before in its view of the chessboard.
    Every image will be compared to the last one to assess if a player's hand moves over the chessboard.

    \par By tuning a threshold, we are able to discard changes of lighting and shadows but detect when a hand (or something else) goes over the chessboard. Then the code waits until changes cease (the hand is supposed to have left the board and hence have finished to move the chess pieces) then the code compares the state of the board to the last known state and now tries to detect what pieces were moved (next section). When that is done this state becomes the last known state to be then compared with the next move.
    
    \subsection{Assessing what move has been made}
    
    \par Now the code has two states (pictures of the board) to compare and the only difference between them should be a valid chess move.
    \par To determine what move was played, we need to look at which squares on the board changed. To do this the images of the board are decomposed in the 64 squares and the corresponding squares are compared (from before and after the played move) by the function detectDiff.
    
    \par The detectDiff function has every single square on the board passed into it from both before the move was made and after. This passes each square through two filters, one of them converts them to LUV and applies a customized threshold that helps separate the color of black board tiles from that of black pieces as can be seen in figure 6. The other filter converts them into HSV and applies a gray filter with no thresholds, this helps separate the color of white board tiles from white pieces as can be seen in figure 5.\\
        \par Technical details:
    To compute the difference between two pictures, we used the structural similarity function imported from the Skimage library.\\
        \begin{figure}[h]
        \centering
        \includegraphics[width=1.2in]{images/F3a.jpg}
        \includegraphics[width=1.2in]{images/F3b.jpg}
        \includegraphics[width=1.2in]{images/F3HSV.jpg}
        \includegraphics[width=1.2in]{images/F3LUV.jpg}
        \caption{Before movement, after movement, HSV comparison and LUV comparison}
        \label{fig:Detecting}
    \end{figure}
        \begin{figure}[h]
        \centering
        \includegraphics[width=1.2in]{images/h4a.jpg}
        \includegraphics[width=1.2in]{images/h4b.jpg}
        \includegraphics[width=1.2in]{images/h4HSV.jpg}
        \includegraphics[width=1.2in]{images/h4LUV.jpg}
        \caption{Before movement, after movement, HSV comparison and LUV comparison}
        \label{fig:Detecting}
    \end{figure}
    \par The logic involved with figuring out the state of our board and what moves can be made were implemented using the standard python chess library.
    \par By sorting the squares by the difference scores (how resembling are the two compared squares), we start by taking the two most affected squares and generate all the possible permutations between them. This list of permutations is then compared to all the legal moves available on the board. If no legal moves are detected, we add the next most affected square and parse the permutations again. As soon as one of the permutations is detected as a legal move, it is pushed into the board and the game information is updated.
    Once the move is confirmed, it is announced out loud and logged into a text file.
    
\par That part of the code proved to be the most difficult, for multiple reasons.
\par First the overlap of the pieces : since we are not filming the board from a centered position above it, there is some perspective. The chess pieces are way taller than the size of a side of the squares on the board. Once the board is projected in 2D this leads to pieces sometimes being over 2 squares or even 3 for the queen or the king which are very big pieces. This lead to mistakes in the detected position of the moves : moving a piece could create more change in the square it was obstructing than the one it occupied. And also piece could partly obstruct other pieces from the camera, which also lead to false detection.

\par Also the tuning was long because we had to find a way to efficiently differientiate pieces and tiles of the same colors : the white pieces are made from the same colored wood as the white tiles.

\subsection{Experiment and Results}

\par We first started building the way to detect the chessboard using an openCV function made for that and realised that it only worked when the pieces are not on the board. We took advantage of the starting position which leaves the middle of the board empty to detect it. We could then use the homography to project it.

\par  We then worked on figuring out a way to find the move played. The selection of filters and the custom threshold of the LUV filter to detect differences in squares took 11 hours of trial and error. This ended up being worth it as these filters are the main component that made this project work.

\begin{figure}[h]
    \centering
    \includegraphics[width=2.5in]{images/settingUp.png}
    \caption{The interface we built to tune the filters using sliders for minimum and maximum values of each color space}
    \label{fig:Detecting}
\end{figure}
    
\par Having built this component we first used keyboard input to indicate when a move had been played to test it out in real conditions. We obtained a first working code. And then went on adding a "motion detection part" to the algorithm to make it more autonomous.

  \section{Conclusion}
  The project was a success beyond our expectations. It works somewhat reliably and is intuitive enough thanks to the vocal feedback of the computer. It can be used by average people. \\
 \newline
  Note about the file run by the pipeline : \\
  In the pipeline the code uses a recorded footage of a chess game played by us as 1 frame per second. The only difference with the code used for the presentation is that it does not output the footage on the screen and does not give vocal feedback. But it does locate the board and the movements live. It outputs the detected moves in a text file along with a representation of the board at every frame.
  
  \subsection{What we learned}
    During the course of this project, we figured out how to create a forced perspective, create filters for easier recognition, the different color spaces and where they are useful and how we can compute the difference between two pictures.
  \subsection{Contributions}
     Both of us contributed evenly and we worked on the same functions together. We always had our mind focused on the same issues to solve them.
     
  \subsection{Future Work}
    \par In order to make this code more accessible, it would need to become more generalized and work with different chess sets. It currently only works on the particular chess set that I (Arnór) own, which is a handmade set sold on a Moroccan street market decades ago. The simplest way to generalize it would be to tune it to a standard chess set that is mass produced and widely available. The variation between sets is the colors used, shape and size of pieces and how glossy the finish is.
    
    \par Another improvement that can be made is for the chess logic to detect invalid moves instead of guessing the most probable legal move. This would take a significant amount of work as the current logic relies on guessing on the most likely moves.
  
\end{document}
